#include <stdio.h>
#include <dlfcn.h>

#include <dmx/plugin.h>

#include <trycatch.h>


int main(int argc, char **argv)
{
  int i;
  int verbose=1;

  if (argc>1 && strcmp(argv[1],"-b")==0) {verbose=0; argc--; argv++;}

  for (i=1; i<argc; i++)
    {
      dmxplugin_t *p1 = loadPlugin (NULL, argv[i]);
      if (verbose)
        printf ("plugin-location: %s\n", argv[i]);
      if (p1)
        {
          dmxuniverse_t u1;

          if (verbose)
            {
              printf ("  found functions: ");
              if (p1->bind_universe)
                printf ("bind_universe ");
              if (p1->unbind_universe)
                printf ("unbind_universe ");
              if (p1->send_universe)
                printf ("send_universe ");
              if (p1->get_plugin_info)
                printf ("get_plugin_info ");
              printf ("\n");
            }

          if (p1->get_plugin_info)
            {
              dmxplugin_info_t pi;
              if (p1->get_plugin_info (&pi) >= 0)
                {
                  if (verbose)
                    {
                      printf ("  protocol:\n");
                      printf ("    vendor..: %s\n", pi.vendor_name);
                      printf ("    name....: %s Release %.3f\n", pi.proto_name, pi.proto_release);
                      printf ("  plugin:\n");
                      printf ("    release.: %.3f\n", pi.release);
                      printf ("    author..: %s\n", pi.author);
                      printf ("    e-mail..: %s\n", pi.email);
                      printf ("    #-univ..: %d\n", pi.num_universes);
                    }
                  else
                    {
                      printf ("%s:%s:%.3f:%s:%s:%d\n", pi.vendor_name, pi.proto_name, pi.proto_release, pi.author, pi.email, pi.num_universes);
                    }
                }
            }

          if (p1->delete)
            p1->delete (p1);
        }
      else
        printf ("  unable to load plugin\n");
      if (verbose)
        printf ("\n");
    }

  return 0;
}

