#include <stdio.h>
#include <dlfcn.h>

#include <dmx/plugin.h>

#include <curses.h>


int width=0,height=0;

int my_notify (dmxuniverse_t *u)
{
  if (u)
    {
      int yn = (height-1)/2;
      int xn = (width/3);

      int x, y;

      mvprintw (0,5,"%d     ", u->numslots);

      for (y=0; y<yn; y++)
        for (x=0; x<xn; x++)
          if (y*xn + x < u->numslots)
            mvprintw (y,x,"%02X", u->buffer[y*xn + x]);

      refresh ();
    }
  else
    printf ("my_notify: universe is NULL\n");
}



int main(int argc, char **argv)
{
  if (argc > 1)
    {
      dmxplugin_t *p1 = loadPlugin (NULL, argv[1]);
      if (p1)
        {
          dmxuniverse_t u1;

          WINDOW *mwin = initscr();
          getmaxyx(mwin, height, width);
          cbreak();
          noecho();
          intrflush(stdscr, FALSE);
          keypad(stdscr, TRUE);

          mvprintw (0,30, "dmx-dump");
#if 0
          for (y=0; y < (height-1)/2; y++)
            {
              for (x=0; x < width/3; x++)
                mvprintw (y*2+1,x, "%d", );
            }
#endif
          u1.notify = my_notify;
          if (p1->bind_universe (0, &u1) >= 0)
            {


            while (wgetch (mwin)!='q')
              {
              }

            p1->unbind_universe (0, &u1);
          }

          echo ();
          endwin ();

          if (p1->delete)
            p1->delete (p1);
        }
      else
        printf ("  unable to load plugin\n");
      printf ("\n");
    }
  sleep(2);
  return 0;
}



