/* plugin.hh
 *
 */

#include <dmx/plugin.h>

class DMXPlugin;

class DMXUniverse
{
private:
  DMXPlugin     *plugin;
  dmxuniverse_t *u;

public:
  DMXUniverse (DMXPLugin *);
  DMXUniverse ();

  virtual ~DMXUniverse();

  virtual int notify ();

  void  setValue (int idx, int value);
  int   getValue (int idx);
  void  flush ();
  void  flushTo (DMXPlugin *);
};


class DMXPlugin
{
private:
  dmxplugin_t      *plugin;
  dmxplugin_info_t info;

  DMXPlugin () {}

public:
  DMXPlugin (string name)  { plugin = loadPlugin (NULL, name.c_str()); if (plugin) plugin->get_plugin_info(&info);   }

  virtual ~DMXPlugin ();

  string vendorName ()   { return string(info.vendor_name); };
  string protocolName () { return string(info.proto_name); };
  string author ()       { return string(info.author); };
  string email ()        { return string(info.email);  };
  int    universeCount ()   { return info.num_universes; };
  float  protocolRelease () { return info.proto_release; };
  float  release ()         { return info.release; };

  int bindUniverse (DMXUniverse *u);
  int unbindUniverse (DMXUniverse *u);

  flush (DMXUniverse *);
};

#if 0
DMXPlugin   dmxout ("dmx4linux");
DMXUniverse u(&dmxout);

for (int i=0; i<10; i++) u.setValue (i,i);
u.flush(0, &dmxout);
#endif



