
#include "dmxoe_codec.h"

void
hex_dump(U8 buf[], unsigned len) {
  int i;
  for(i = 0; i<len; i++) {
    if(i != 0) {
      if(i% 4==0) printw(" ");
      if(i%(4*6)==0) printw("\n");
    }
    printw("%02X ", buf[i]);
  }
}

void
display_header(header* phead) {
  int i;
  char buf[16];
  inet_ntop(AF_INET, &phead->srcip, buf, sizeof(buf));
  printw("\nversion: %04X  src ip: %s", phead->version, buf);
  printw("\nnet slot:   ");
  for(i = 0; i<4; i++) {
    printw("%5d ", phead->slot[i]);
  }
  printw("\nlength:     ");
  for(i = 0; i<4; i++) {
    printw("%5d ", phead->length[i]);
  }
  printw("\nrle offset: ");
  for(i = 0; i<5; i++) {
    printw("%5d ", phead->rle_offset[i]);
  }
  printw("\nsequence:    %d", ntohs(phead->sequence));
#if 0
  printw("\nlong sig:    ");
  hex_dump(phead->long_sig, sizeof(phead->long_sig));
  printw("\nshould be:   " LONG_SIG);
#else
  printw("\nlong sig:    ");
  hex_dump(phead->long_sig0, sizeof(phead->long_sig0));
  hex_dump(phead->long_sig1, sizeof(phead->long_sig1));
  printw ("   src-name: %s\n", phead->devicename);
#endif
}

